const pkg = require('./../package.json');
require('please-upgrade-node')(pkg);

const program = require('commander');

const updateNotifier = require('update-notifier');

const command = require('./cli-command');

updateNotifier({ pkg }).notify();

program
  .version(pkg.version)
  .usage(command.usage)
  .description(command.description)
  .action(function programAction (_, args) {
    command.action(args, this.opts());
  });

(command.options || [])
  .forEach(opt => program.option(
    opt.command,
    opt.description,
    opt.parse || (value => value),
    opt.default
  ));

const args = process.argv;
if (args.length === 2) {
  args.push('--help');
}
program.parse(args);
